#include <string>
#include <vector>
#include <map>
#include <cstddef>

#define MAX_48 0xFFFFFFFFFFFF
#define WORKER_COUNT 1024
#define MAGIC_NUM 25214903917

struct feature_t {
	int32_t spacing;
	int32_t separation;
	int32_t salt;
	bool linear_sep = true;

	feature_t(int32_t spacing, int32_t separation, int32_t salt, bool linear_sep = true) {
		this->spacing = spacing;
		this->separation = separation;
		this->salt = salt;
		this->linear_sep = linear_sep;
	}
};
struct condition_t {
	int32_t x, res_x, y, res_y, diff;
	uint64_t part_seed;
	bool linear_sep;

	static condition_t make(const feature_t &feat, int32_t x, int32_t y);
};

extern const std::map<std::string, feature_t> FEATURES;

namespace engine {
	void init(const std::vector<condition_t> &tasks);
	void free();
	size_t batch_size();
	const std::vector<uint64_t> &run(size_t start, size_t end);
}
